;****************************************************
;lab3
;approx 2 ms delay program with 2 status leds to show
;start and end of delay.
;will use tmr0 peripheral
;****************************************************

	List P=12F508, R=hex
	include "P12F508.inc"		;load the include file
	__CONFIG _IntRC_OSC & _WDT_OFF & _CP_OFF & _MCLRE_ON

		cblock	0x07
	COUNTER
		endc

		org	0x00
	movwf	OSCCAL		;setup INTRC calibration
	goto	Start		;

;===========================================================
;call routines

;routine to preload tmr0
Settmr0
	movlw	0x38		;reset tmr0 to count again
	movwf	TMR0		;could use clrf here but this
	retlw	0x01		;lets you put in test/spec values

;routine to preload counter
Setcounter
	movlw	0x0A		;set # of tmr0 roll overs needed
	movwf	COUNTER		;
	retlw	0x01

;routine to decrement and test counter to see if 2 ms has expired
Decr_counter
	decf	COUNTER,F	;decrement counter by 1
	btfsc	STATUS,Z	;test to see if (1Eh) rounds of tmr0 have been run
	call	Light_2nd_led	;
	call	Settmr0		;
	retlw	0x01

;routine to light 2nd led
Light_2nd_led
	bsf	GPIO,5		;light time expires led
	retlw	0x01

;===========================================================
	
Start
	;initialize tmr0
	movlw	b'00001000'	;setup prescaler&tmr0
	option			;load option reg

Gpio	;initialize gpio port& set program running led	
				;clear GPIO
	clrf	GPIO		;load output latch w/zeros
	movlw	0x00		;configure ports to outputs
	tris	GPIO		;
	
	call	Settmr0		;setup tmr0
	call	Setcounter	;setup counter
	bsf	GPIO,4		;light pgrm running led

Test_tmr0
	;loop to test to see if trm0 has rolled over
	movlw	0x05		;load test value
	subwf	TMR0,W		;test tmr0
	btfsc	STATUS,C	;check if in window	
	goto	Test_tmr0	;loop back
	call	Decr_counter	;decr the counter
	goto	Test_tmr0	;loop back and test again

	end
